#!/usr/bin/env python
# -*- coding: UTF-8 -*-
# Copyright 2014
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import urllib,urllib2,re,xbmcplugin,xbmcgui,xbmc,xbmcaddon,HTMLParser,sys
from tools import *
from xbmcgui import ListItem
from BeautifulSoup import BeautifulSoup

versao = '0.0.1'
addon_id = 'plugin.audio.musicasgospel'
selfAddon = xbmcaddon.Addon(id=addon_id)
addonfolder = selfAddon.getAddonInfo('path')
artfolder = addonfolder + '/resources/img/'
fanart = addonfolder + '/fanart.jpg'

def Menu_Principal():
	addDir('Artistas','-',1,artfolder + 'categorias.jpg')
	addDir('Ultimos','http://www.ouvirmusicasgospel.net/#',2,'atualizacao.png')
	


def Categorias():
    addDir('A','http://www.ouvirmusicasgospel.net/?letra=A',2,artfolder + 'A.jpg')
    addDir('B','http://www.ouvirmusicasgospel.net/?letra=B',2,artfolder + 'B.jpg')
    addDir('C','http://www.ouvirmusicasgospel.net/?letra=C',2,artfolder + 'C.jpg')
    addDir('D','http://www.ouvirmusicasgospel.net/?letra=D',2,artfolder + 'D.jpg')
    addDir('E','http://www.ouvirmusicasgospel.net/?letra=E',2,artfolder + 'E.jpg')
    addDir('F','http://www.ouvirmusicasgospel.net/?letra=F',2,artfolder + 'F.jpg')
    addDir('G','http://www.ouvirmusicasgospel.net/?letra=G',2,artfolder + 'G.jpg')
    addDir('H','http://www.ouvirmusicasgospel.net/?letra=H',2,artfolder + 'H.jpg')
    addDir('I','http://www.ouvirmusicasgospel.net/?letra=I',2,artfolder + 'I.jpg')
    addDir('J','http://www.ouvirmusicasgospel.net/?letra=J',2,artfolder + 'J.jpg')
    addDir('K','http://www.ouvirmusicasgospel.net/?letra=K',2,artfolder + 'K.jpg')
    addDir('L','http://www.ouvirmusicasgospel.net/?letra=L',2,artfolder + 'L.jpg')
    addDir('M','http://www.ouvirmusicasgospel.net/?letra=M',2,artfolder + 'M.jpg')
    addDir('N','http://www.ouvirmusicasgospel.net/?letra=N',2,artfolder + 'N.jpg')
    addDir('O','http://www.ouvirmusicasgospel.net/?letra=O',2,artfolder + 'O.jpg')
    addDir('P','http://www.ouvirmusicasgospel.net/?letra=P',2,artfolder + 'P.jpg')
    addDir('Q','http://www.ouvirmusicasgospel.net/?letra=Q',2,artfolder + 'Q.jpg')
    addDir('R','http://www.ouvirmusicasgospel.net/?letra=R',2,artfolder + 'R.jpg')
    addDir('S','http://www.ouvirmusicasgospel.net/?letra=S',2,artfolder + 'S.jpg')
    addDir('T','http://www.ouvirmusicasgospel.net/?letra=T',2,artfolder + 'T.jpg')
    addDir('U','http://www.ouvirmusicasgospel.net/?letra=U',2,artfolder + 'U.jpg')
    addDir('V','http://www.ouvirmusicasgospel.net/?letra=V',2,artfolder + 'V.jpg')
    addDir('W','http://www.ouvirmusicasgospel.net/?letra=W',2,artfolder + 'W.jpg')
    addDir('X','http://www.ouvirmusicasgospel.net/?letra=X',2,artfolder + 'X.jpg')
    addDir('Y','http://www.ouvirmusicasgospel.net/?letra=Y',2,artfolder + 'Y.jpg')
    addDir('Z','http://www.ouvirmusicasgospel.net/?letra=Z',2,artfolder + 'Z.jpg')
   

def listar_artistas(url):
	a = []
	codigo_fonte = abrir_url(url)
	soup = BeautifulSoup(abrir_url(url))
	content = BeautifulSoup(soup.find("table", { "width" : "890" }).prettify())
	resultados = content.findAll("td",  { "style" : "padding:2px; cursor:pointer" })
	for resultado in resultados:
		try:
			image = re.findall(r'img=(.*?)jpg',resultado.img["src"])[0]
		except:
			image = ''
		temp = [resultado.a["href"],"%s" % (html_replace_clean(resultado.text.encode('ascii','xmlcharrefreplace'))),image+'jpg'] 
		a.append(temp)
	total = len(a)
	
	for url2, titulo, img in a:
		titulo = cleanHtml(titulo)
		addDir(titulo,url2,6,img,True,total,'')

def listar_albums_artista(url):
	a = []
	codigo_fonte = abrir_url(url)
	soup = BeautifulSoup(abrir_url(url))
	resultados = soup.findAll("td",  { "style" : "padding:2px; cursor:pointer" })
	for resultado in resultados:
		temp = [resultado.a["href"],"%s" % (resultado.text.encode('ascii', 'ignore')),resultado.img["src"]] 
		a.append(temp)
	total = len(a)
	for url2, titulo, img in a:
		titulo = cleanHtml(titulo)
		addDir(titulo,url2,4,img,False,total,'')
	

def listar_musicas(url):
	progress = xbmcgui.DialogProgress()
	progress.create("PlayCds", "Gerando a playlist...")
	progress.update(0)
	playlist = xbmc.PlayList(1)
	playlist.clear()
	album_id = re.findall(r'cd.php.album=(.*?)$',url)[0]
	xml_url = 'http://www.ouvirmusicasgospel.net/tocarcd7.php?cd_codigo=' + album_id
	soup = BeautifulSoup(abrir_url(xml_url))
	musicas = soup.findAll("track")
	n = 0
	for musica in musicas:
		print musica
		if musica.location:
			liz=xbmcgui.ListItem(musica.creator.text, iconImage='', thumbnailImage='')
			n=n+1
			liz.setInfo('music', {'Title':musica.creator.text,'Album':musica.title.text.replace("CD:",""),'Artist':'','Year':''})
			liz.setProperty('mimetype', 'audio/mpeg')
			playlist.add(musica.location.text, liz)
			progress_ = len(playlist) / float(len(musicas)) * 100
			progress.update(int(progress_))

		if progress.iscanceled():
			return
	xbmcPlayer = xbmc.Player(xbmc.PLAYER_CORE_AUTO)
	xbmcPlayer.play(playlist)


################################################
#    Funções relacionadas a media.             #
#                                              #
################################################

def addLink(name,url,iconimage):
	ok=True
	liz=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
	liz.setProperty('fanart_image', fanart)
	liz.setInfo( type="Video", infoLabels={ "Title": name } )
	ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=url,listitem=liz)
	return ok

def addDir(name,url,mode,iconimage,pasta=True,total=1,plot=''):
	u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
	ok=True
	liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
	liz.setProperty('fanart_image', fanart)
	liz.setInfo( type="video", infoLabels={ "title": name, "plot": plot } )
	ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=pasta,totalItems=total)
	return ok



################################################
#    Pega os parametros                        #
#                                              #
################################################

def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param

      
params=get_params()
url=None
name=None
mode=None
iconimage=None


try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass

try:        
        iconimage=urllib.unquote_plus(params["iconimage"])
except:
        pass


print "Mode: "+str(mode)
print "URL: "+str(url)
print "Name: "+str(name)
print "Iconimage: "+str(iconimage)

################################################
#    Destina para cada modo.                   #
#                                              #
################################################

if mode==None or url==None or len(url)<1:
        print "Sem mode"
        print "Inicio: Menu Principal"
        Menu_Principal()

elif mode==1:
	print "Mode: 1 - Categorias"
	Categorias()
	
elif mode==2:
	print "Mode: 2 - Listar Albums"
	listar_artistas(url)

elif mode==4:
	print "Mode: 4 - Listar Musicas"
	listar_musicas(url)

elif mode==6:
	print 'Mode: 6'
	listar_albums_artista(url)
	
xbmcplugin.endOfDirectory(int(sys.argv[1]))